<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>問題6.12 - エノン写像 &mdash; 計算機実習2014</title>
    
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="author" title="このドキュメントについて" href="../about.html" />
    <link rel="top" title="計算機実習2014" href="../index.html" />
    <link rel="next" title="問題6.14 - 外力を受けた減衰振り子" href="../6-14_poincare/6-14.html" />
    <link rel="prev" title="問題6.9 - ロジスティック写像のリアプノフ指数" href="../6-9_lyapunov/6-9.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="../6-14_poincare/6-14.html" title="問題6.14 - 外力を受けた減衰振り子"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="../6-9_lyapunov/6-9.html" title="問題6.9 - ロジスティック写像のリアプノフ指数"
             accesskey="P">前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="label">
<span id="id1"></span><h1><a class="toc-backref" href="#id7">問題6.12 - エノン写像</a><a class="headerlink" href="#label" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="contents topic" id="contents">
<p class="topic-title first">Contents</p>
<ul class="simple">
<li><a class="reference internal" href="#label" id="id7">問題6.12 - エノン写像</a><ul>
<li><a class="reference internal" href="#id2" id="id8">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3" id="id9">作成したプログラム</a></li>
<li><a class="reference internal" href="#id4" id="id10">実習課題</a></li>
<li><a class="reference internal" href="#id5" id="id11">まとめ</a></li>
<li><a class="reference internal" href="#id6" id="id12">参考文献</a></li>
</ul>
</li>
</ul>
</div>
<div class="section" id="id2">
<h2><a class="toc-backref" href="#id8">シミュレーションの目的</a><a class="headerlink" href="#id2" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>これまでは、さまざまな点で教育的であるロジスティック写像について議論してきた。今回は2次元の写像</p>
<div class="math" id="equation-e1">
<p><span class="eqno">(1)</span><img src="../_images/math/236eaa74040423b8ed697d972c012e0a58b9013e.png" alt="x_{n+1} = y_{n} + 1 - ax_{n}^{2}"/></p>
</div><div class="math" id="equation-e2">
<p><span class="eqno">(2)</span><img src="../_images/math/060d2f7af4069ef4b9268dd6094381f7589f73e8.png" alt="y_{n+1} = bx_{n}"/></p>
</div><p>で与えられる点(<img class="math" src="../_images/math/8f7af1c5494a324b7039d7045e71f65fecfdbc1b.png" alt="x_{n}"/>,<img class="math" src="../_images/math/79b8dd7ab5a5d68add67d10edf90210d8c56315b.png" alt="y_{n}"/>)の例を考える。写像<a href="#equation-e1">(1)</a>,<a href="#equation-e2">(2)</a>はエノン(H&#8217;{e}non)により最初に考えられたもので、小惑星や衛星の振る舞いとの関連がその動機であった。</p>
</div>
<div class="section" id="id3">
<h2><a class="toc-backref" href="#id9">作成したプログラム</a><a class="headerlink" href="#id3" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>本シミュレーションで作成・使用したプログラムを以下に示す。</p>
<ul class="simple">
<li>パラメータの設定ダイアログ( <a class="reference download internal" href="../_downloads/SetParameter.py"><tt class="xref download docutils literal"><span class="pre">SetParameter.py</span></tt></a> )</li>
</ul>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!usr/bin/env python </span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, Mqy 2014.</span>
<span class="c">#</span>

<span class="kn">from</span> <span class="nn">Tkinter</span> <span class="kn">import</span> <span class="o">*</span>

<span class="k">class</span> <span class="nc">SetParameter</span><span class="p">():</span>

    <span class="k">def</span> <span class="nf">show_setting_window</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">parameters</span><span class="p">,</span> <span class="n">commands</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Show a parameter setting window.</span>
<span class="sd">                </span>
<span class="sd">        parameters: A list of dictionaries {&#39;parameter name&#39;:default_value}</span>
<span class="sd">        commands: A dictionary {&#39;name of button&#39;: command}</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span> <span class="o">=</span> <span class="n">Tk</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;Control Widget&#39;</span><span class="p">)</span>
        
        <span class="n">frame1</span> <span class="o">=</span> <span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">frame1</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;top&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">entry</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">parameter</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">parameters</span><span class="p">):</span>
            <span class="n">label</span> <span class="o">=</span> <span class="n">Label</span><span class="p">(</span><span class="n">frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="n">parameter</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="s">&#39; = &#39;</span><span class="p">)</span>
            <span class="n">label</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">row</span><span class="o">=</span><span class="n">i</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">sticky</span><span class="o">=</span><span class="n">E</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Entry</span><span class="p">(</span><span class="n">frame1</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">10</span><span class="p">))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">row</span><span class="o">=</span><span class="n">i</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">delete</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">END</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">parameter</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">1</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">focus_set</span><span class="p">()</span>
       
        <span class="n">frame2</span> <span class="o">=</span> <span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">frame2</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;bottom&#39;</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">name</span><span class="p">,</span> <span class="n">command</span> <span class="ow">in</span> <span class="n">commands</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="n">button</span> <span class="o">=</span> <span class="n">Button</span><span class="p">(</span><span class="n">frame2</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="n">name</span><span class="p">,</span> <span class="n">command</span><span class="o">=</span><span class="n">command</span><span class="p">)</span>
            <span class="n">button</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;left&#39;</span><span class="p">,</span> <span class="n">fill</span><span class="o">=</span><span class="s">&#39;x&#39;</span><span class="p">)</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">mainloop</span><span class="p">()</span>
       
    <span class="k">def</span> <span class="nf">quit</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">destroy</span><span class="p">()</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>エノン写像の描画を行うプログラム( <a class="reference download internal" href="../_downloads/Henon.py"><tt class="xref download docutils literal"><span class="pre">Henon.py</span></tt></a> )</li>
</ul>
<p>このプログラムでは、実際の写像の値の計算の反復とその描画の指示を行っており、シミュレーションの中核となる部分である。大きく分けて3つの部分からなっており、SetParameterから値を代入する部分(assignment)、式<a href="#equation-e1">(1)</a><a href="#equation-e2">(2)</a>に基づいて時間発展を計算する部分(calc)、そしてその値をプロットする部分(plot_x_and_y)である。それぞれの部分は互いに独立していて、本体の方で関数を呼び出してやる必要がある。これはテストの際の効率化と、関数の再利用性を考慮に入れたためである。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!/usr/bin/env python</span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>

<span class="kn">import</span> <span class="nn">matplotlib.pylab</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">array</span> 

<span class="k">class</span> <span class="nc">Henon</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>

    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">global</span> <span class="n">ntransient</span><span class="p">,</span> <span class="n">nplot</span>
        <span class="n">ntransient</span> <span class="o">=</span> <span class="mi">1000</span>
        <span class="n">nplot</span> <span class="o">=</span> <span class="mi">10000</span>

    <span class="k">def</span> <span class="nf">assignment</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">module</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">x0</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">module</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">y0</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">module</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">a</span>  <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">module</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">b</span>  <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">module</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>

    <span class="k">def</span> <span class="nf">func</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x_i</span><span class="p">,</span> <span class="n">y_i</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">y_i</span> <span class="o">+</span> <span class="mf">1.0</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">a</span><span class="o">*</span><span class="n">x_i</span><span class="o">**</span><span class="mi">2</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">b</span><span class="o">*</span><span class="n">x_i</span>

    <span class="k">def</span> <span class="nf">calc</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">global</span> <span class="n">x</span><span class="p">,</span> <span class="n">y</span>
        <span class="n">x</span> <span class="o">=</span> <span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;d&#39;</span><span class="p">)</span>
        <span class="n">y</span> <span class="o">=</span> <span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;d&#39;</span><span class="p">)</span>
        <span class="n">x</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">)</span>
        <span class="n">y</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y0</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">ntransient</span><span class="o">+</span><span class="n">nplot</span><span class="p">):</span>
            <span class="n">x</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">func</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">],</span> <span class="n">y</span><span class="p">[</span><span class="n">n</span><span class="p">])[</span><span class="mi">0</span><span class="p">])</span>
            <span class="n">y</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">func</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">],</span> <span class="n">y</span><span class="p">[</span><span class="n">n</span><span class="p">])[</span><span class="mi">1</span><span class="p">])</span>
        <span class="k">return</span> <span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="n">ntransient</span><span class="p">:</span><span class="n">ntransient</span><span class="o">+</span><span class="n">nplot</span><span class="p">],</span><span class="n">y</span><span class="p">[</span><span class="n">ntransient</span><span class="p">:</span><span class="n">ntransient</span><span class="o">+</span><span class="n">nplot</span><span class="p">])</span>

    <span class="k">def</span> <span class="nf">plot_x_and_y</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s">&#39;blue&#39;</span><span class="p">,</span> <span class="n">showing</span><span class="o">=</span><span class="bp">True</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">margin</span> <span class="o">=</span> <span class="mf">0.1</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mf">1.0</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s">&#39;o&#39;</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="n">color</span><span class="p">,</span>
                           <span class="n">label</span><span class="o">=</span><span class="s">r&#39;$x_{0}=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">)</span> <span class="o">+</span> <span class="s">&#39; : &#39;</span> 
                           <span class="o">+</span> <span class="s">r&#39;$y_{0}=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y0</span><span class="p">)</span> <span class="o">+</span> <span class="s">&#39; : &#39;</span>
                           <span class="o">+</span> <span class="s">r&#39;$a=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">a</span><span class="p">)</span> <span class="o">+</span> <span class="s">&#39; : &#39;</span>
                           <span class="o">+</span> <span class="s">r&#39;$b=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">b</span><span class="p">)</span>
                   <span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="nb">min</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">margin</span><span class="p">,</span> <span class="nb">max</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">margin</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">(</span><span class="nb">min</span><span class="p">(</span><span class="n">y</span><span class="p">)</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">margin</span><span class="p">,</span> <span class="nb">max</span><span class="p">(</span><span class="n">y</span><span class="p">)</span> <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">margin</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s">r&#39;$x$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s">r&#39;$y$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">r&quot;$\mathrm{H\&#39;{e}non\ map}$&quot;</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="s">&quot;best&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">showing</span><span class="p">:</span> <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
        <span class="k">else</span><span class="p">:</span> <span class="k">pass</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>実習課題aで用いるプログラム( <a class="reference download internal" href="../_downloads/6-12_henon-a.py"><tt class="xref download docutils literal"><span class="pre">6-12_henon-a.py</span></tt></a> )</li>
</ul>
<p>課題aを実行するため、単純に与えたパラメータからエノン写像を描画するプログラムとなっている。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!/usr/bin/env python</span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>

<span class="kn">import</span> <span class="nn">SetParameter</span> <span class="kn">as</span> <span class="nn">sp</span>
<span class="kn">import</span> <span class="nn">Henon</span>

<span class="k">def</span> <span class="nf">clicked</span><span class="p">():</span>
    <span class="n">henon</span><span class="o">.</span><span class="n">assignment</span><span class="p">(</span><span class="n">module</span><span class="o">=</span><span class="n">window</span><span class="p">)</span>
    <span class="n">window</span><span class="o">.</span><span class="n">quit</span><span class="p">()</span>
    <span class="n">henon</span><span class="o">.</span><span class="n">plot_x_and_y</span><span class="p">(</span><span class="n">henon</span><span class="o">.</span><span class="n">calc</span><span class="p">()[</span><span class="mi">0</span><span class="p">],</span> <span class="n">henon</span><span class="o">.</span><span class="n">calc</span><span class="p">()[</span><span class="mi">1</span><span class="p">],</span> <span class="n">color</span><span class="o">=</span><span class="s">&#39;black&#39;</span><span class="p">)</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">parameters</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;x0&#39;</span><span class="p">:</span><span class="mf">0.0</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;y0&#39;</span><span class="p">:</span><span class="mf">0.0</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;a&#39;</span><span class="p">:</span><span class="mf">1.4</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;b&#39;</span><span class="p">:</span><span class="mf">0.3</span><span class="p">}]</span>
    <span class="n">window</span> <span class="o">=</span> <span class="n">sp</span><span class="o">.</span><span class="n">SetParameter</span><span class="p">()</span>
    <span class="n">henon</span> <span class="o">=</span> <span class="n">Henon</span><span class="o">.</span><span class="n">Henon</span><span class="p">()</span>
    <span class="n">window</span><span class="o">.</span><span class="n">show_setting_window</span><span class="p">(</span><span class="n">parameters</span><span class="p">,</span> <span class="p">{</span><span class="s">&#39;OK&#39;</span><span class="p">:</span><span class="n">clicked</span><span class="p">})</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>実習課題cで用いるプログラム( <a class="reference download internal" href="../_downloads/6-12_henon-c.py"><tt class="xref download docutils literal"><span class="pre">6-12_henon-c.py</span></tt></a> )</li>
</ul>
<p>課題cを実行するため、設定したパラメータと、そこからプログラム内で与えた<img class="math" src="../_images/math/4505f4a09bdb322b02fb68405eda3f6ed367e3a4.png" alt="\Delta x_{0}"/>、<img class="math" src="../_images/math/6f0090f52184d09ae0d0d2c236335281591d4282.png" alt="\Delta y_{0}"/>だけ初期条件のずれた2つのエノン写像を描画するプログラムである。Henonの関数plot_x_and_yにshowing=Falseを指定することで、プロットしたグラフが表示されないようにでき、2つ目の曲線を重ねて描くことができる。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!/usr/bin/env python</span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>

<span class="kn">import</span> <span class="nn">SetParameter</span> <span class="kn">as</span> <span class="nn">sp</span>
<span class="kn">import</span> <span class="nn">Henon</span>

<span class="n">delta_x0</span> <span class="o">=</span> <span class="mf">0.0000001</span>
<span class="n">delta_y0</span> <span class="o">=</span> <span class="o">-</span><span class="mf">0.00001</span>

<span class="k">def</span> <span class="nf">clicked</span><span class="p">():</span>
    <span class="n">henon</span><span class="o">.</span><span class="n">assignment</span><span class="p">(</span><span class="n">module</span><span class="o">=</span><span class="n">window</span><span class="p">)</span>
    <span class="n">window</span><span class="o">.</span><span class="n">quit</span><span class="p">()</span>
    
    <span class="c"># --- 1つ目のエノン写像の描画 ---</span>
    <span class="n">henon</span><span class="o">.</span><span class="n">plot_x_and_y</span><span class="p">(</span><span class="n">henon</span><span class="o">.</span><span class="n">calc</span><span class="p">()[</span><span class="mi">0</span><span class="p">],</span> <span class="n">henon</span><span class="o">.</span><span class="n">calc</span><span class="p">()[</span><span class="mi">1</span><span class="p">],</span>
                      <span class="n">color</span><span class="o">=</span><span class="s">&#39;red&#39;</span><span class="p">,</span> <span class="n">showing</span><span class="o">=</span><span class="bp">False</span>
                      <span class="p">)</span>
    
    <span class="c"># --- 近傍点の設定 ---</span>
    <span class="n">henon</span><span class="o">.</span><span class="n">x0</span> <span class="o">=</span> <span class="n">henon</span><span class="o">.</span><span class="n">x0</span> <span class="o">+</span> <span class="n">delta_x0</span>
    <span class="n">henon</span><span class="o">.</span><span class="n">y0</span> <span class="o">=</span> <span class="n">henon</span><span class="o">.</span><span class="n">y0</span> <span class="o">+</span> <span class="n">delta_y0</span>
    
    <span class="c"># --- 2つ目のエノン写像の描画 ---</span>
    <span class="n">henon</span><span class="o">.</span><span class="n">plot_x_and_y</span><span class="p">(</span><span class="n">henon</span><span class="o">.</span><span class="n">calc</span><span class="p">()[</span><span class="mi">0</span><span class="p">],</span> <span class="n">henon</span><span class="o">.</span><span class="n">calc</span><span class="p">()[</span><span class="mi">1</span><span class="p">],</span>
                      <span class="n">color</span><span class="o">=</span><span class="s">&#39;blue&#39;</span><span class="p">,</span> <span class="n">showing</span><span class="o">=</span><span class="bp">True</span>
                      <span class="p">)</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>

    <span class="n">parameters</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;x0&#39;</span><span class="p">:</span><span class="mf">0.0</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;y0&#39;</span><span class="p">:</span><span class="mf">0.0</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;a&#39;</span><span class="p">:</span><span class="mf">1.4</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;b&#39;</span><span class="p">:</span><span class="mf">0.3</span><span class="p">}]</span>
    <span class="n">window</span> <span class="o">=</span> <span class="n">sp</span><span class="o">.</span><span class="n">SetParameter</span><span class="p">()</span>
    <span class="n">henon</span> <span class="o">=</span> <span class="n">Henon</span><span class="o">.</span><span class="n">Henon</span><span class="p">()</span>
    <span class="n">window</span><span class="o">.</span><span class="n">show_setting_window</span><span class="p">(</span><span class="n">parameters</span><span class="p">,</span> <span class="p">{</span><span class="s">&#39;OK&#39;</span><span class="p">:</span><span class="n">clicked</span><span class="p">})</span> <span class="c"># パラメータの設定</span>
</pre></div>
</td></tr></table></div>
</div>
<div class="section" id="id4">
<h2><a class="toc-backref" href="#id10">実習課題</a><a class="headerlink" href="#id4" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ol class="loweralpha simple">
<li><img class="math" src="../_images/math/f7c3f2c17fed1207eab5091d69b48f1bf6f06b5f.png" alt="a=1.4"/>および<img class="math" src="../_images/math/8a35fe6bee407f9d7fbe7f21922876cfedb5c3be.png" alt="b=0.3"/>として、式<a href="#equation-e1">(1)</a>,<a href="#equation-e2">(2)</a>の計算を反復して行え。<img class="math" src="../_images/math/30ea02e11603dd66c2253aaffb17d33ed6d2ee9d.png" alt="x_{0}=0"/>,<img class="math" src="../_images/math/4ec66812694d03784dddd5c589f7bd73983ec1e2.png" alt="y_{0}=0"/>から始め、<img class="math" src="../_images/math/c76848ae582320a26e12cbf141d8727fda3aff85.png" alt="10^{4}"/>回の反復の結果をプロットせよ。始めの過渡的な期間の結果はプロットしない。第2の初期条件<img class="math" src="../_images/math/876155863b0ef087e63636eea78e0f4077f40494.png" alt="x_{0}=0.63 135 448"/>、<img class="math" src="../_images/math/b6a378ee8ba980d2e6b74383ad5a26536d581893.png" alt="y_{0}=0.18 940 634"/>から始めて同様の図を描いて、それら2つの図の形を比較せよ。2つの曲線の形は初期条件によらないか。</li>
</ol>
<p><img class="math" src="../_images/math/f7c3f2c17fed1207eab5091d69b48f1bf6f06b5f.png" alt="a=1.4"/>、<img class="math" src="../_images/math/8a35fe6bee407f9d7fbe7f21922876cfedb5c3be.png" alt="b=0.3"/>として式<a href="#equation-e1">(1)</a><a href="#equation-e2">(2)</a>の計算を行い、初期値<img class="math" src="../_images/math/30ea02e11603dd66c2253aaffb17d33ed6d2ee9d.png" alt="x_{0}=0"/>、<img class="math" src="../_images/math/4ec66812694d03784dddd5c589f7bd73983ec1e2.png" alt="y_{0}=0"/>から始めて<img class="math" src="../_images/math/c76848ae582320a26e12cbf141d8727fda3aff85.png" alt="10^{4}"/>回の反復の結果をプロットする。2.3で示したプログラムによりこれを実行し、得られたグラフを<a class="reference internal" href="#fig-6-12-f1"><em>図1</em></a>に示す。このグラフから、<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>-<img class="math" src="../_images/math/b124ff74afb0914bb434e8fb849eb56d734412f8.png" alt="y"/>で描かれる曲線は円弧状の拡がりの中で折りたたまれたような形となっていることが分かる。次に、初期条件を<img class="math" src="../_images/math/876155863b0ef087e63636eea78e0f4077f40494.png" alt="x_{0}=0.63 135 448"/>、<img class="math" src="../_images/math/b6a378ee8ba980d2e6b74383ad5a26536d581893.png" alt="y_{0}=0.18 940 634"/>としたときのグラフを<a class="reference internal" href="#fig-6-12-f2"><em>図2</em></a>に示す。このグラフは先の図と同じ形状をしており、曲線の形は初期条件によらないことが分かる。</p>
<div class="align-center figure" id="fig-6-12-f1">
<a class="reference internal image-reference" href="../_images/figure_11.png"><img alt="../_images/figure_11.png" src="../_images/figure_11.png" style="width: 12.5cm;" /></a>
<p class="caption">初期値<img class="math" src="../_images/math/30ea02e11603dd66c2253aaffb17d33ed6d2ee9d.png" alt="x_{0}=0"/>、<img class="math" src="../_images/math/4ec66812694d03784dddd5c589f7bd73983ec1e2.png" alt="y_{0}=0"/>でのエノン写像</p>
</div>
<div class="align-center figure" id="fig-6-12-f2">
<a class="reference internal image-reference" href="../_images/figure_2.png"><img alt="../_images/figure_2.png" src="../_images/figure_2.png" style="width: 12.5cm;" /></a>
<p class="caption">初期値<img class="math" src="../_images/math/876155863b0ef087e63636eea78e0f4077f40494.png" alt="x_{0}=0.63 135 448"/>、<img class="math" src="../_images/math/b6a378ee8ba980d2e6b74383ad5a26536d581893.png" alt="y_{0}=0.18 940 634"/>でのエノン写像</p>
</div>
<ol class="loweralpha simple" start="3">
<li>系がカオス的であるかどうか、つまり初期条件に敏感であるかどうかを決定せよ。2つの互いに非常に近い2点から始めて、それらの軌跡を観察せよ。2つの軌跡に異なる色を付けよ。</li>
</ol>
<p>互いに近い2点を初期値として反復して計算を行い、それらの軌跡を同時にプロットしたものを<a class="reference internal" href="#fig-6-12-f3"><em>図3</em></a>に示す。図から、非常に近い2つの初期条件から開始した曲線は、aでも見たようにその曲線の形は初期条件によらない。しかしながら、その曲線の中で離散的にプロットされる場所は異なっていることが分かる。</p>
<div class="align-center figure" id="fig-6-12-f3">
<a class="reference internal image-reference" href="../_images/figure_3.png"><img alt="../_images/figure_3.png" src="../_images/figure_3.png" style="width: 12.5cm;" /></a>
<p class="caption">初期値<img class="math" src="../_images/math/30ea02e11603dd66c2253aaffb17d33ed6d2ee9d.png" alt="x_{0}=0"/>、<img class="math" src="../_images/math/4ec66812694d03784dddd5c589f7bd73983ec1e2.png" alt="y_{0}=0"/>とその近傍点について、パラメータ<img class="math" src="../_images/math/f7c3f2c17fed1207eab5091d69b48f1bf6f06b5f.png" alt="a=1.4"/>、<img class="math" src="../_images/math/8a35fe6bee407f9d7fbe7f21922876cfedb5c3be.png" alt="b=0.3"/>としたときのエノン写像</p>
</div>
</div>
<div class="section" id="id5">
<h2><a class="toc-backref" href="#id11">まとめ</a><a class="headerlink" href="#id5" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>2次元の写像であるエノン写像について、その曲線の形状は初期値によらないこと、すなわちエノンアトラクタの存在について知ることができた。</p>
</div>
<div class="section" id="id6">
<h2><a class="toc-backref" href="#id12">参考文献</a><a class="headerlink" href="#id6" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li>ハーベイ・ゴールド,ジャン・トボチニク,石川正勝・宮島佐介訳『計算物理学入門』,ピアソン・エデュケーション, 2000.</li>
</ul>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">問題6.12 - エノン写像</a><ul>
<li><a class="reference internal" href="#id2">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3">作成したプログラム</a></li>
<li><a class="reference internal" href="#id4">実習課題</a></li>
<li><a class="reference internal" href="#id5">まとめ</a></li>
<li><a class="reference internal" href="#id6">参考文献</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="../6-9_lyapunov/6-9.html"
                        title="前の章へ">問題6.9 - ロジスティック写像のリアプノフ指数</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="../6-14_poincare/6-14.html"
                        title="次の章へ">問題6.14 - 外力を受けた減衰振り子</a></p>
  <h3>このページ</h3>
  <ul class="this-page-menu">
    <li><a href="../_sources/6-12_henon/6-12.txt"
           rel="nofollow">ソースコードを表示</a></li>
  </ul>
<div id="searchbox" style="display: none">
  <h3>クイック検索</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="検索" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    モジュール、クラス、または関数名を入力してください
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="../6-14_poincare/6-14.html" title="問題6.14 - 外力を受けた減衰振り子"
             >次へ</a> |</li>
        <li class="right" >
          <a href="../6-9_lyapunov/6-9.html" title="問題6.9 - ロジスティック写像のリアプノフ指数"
             >前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2014, Shotaro Fujimoto.
      このドキュメントは <a href="http://sphinx-doc.org/">Sphinx</a> 1.2.2 で生成しました。
    </div>
  </body>
</html>